#!/usr/bin/ruby -w

require '../lib/gff.rb';
require '../lib/gmm.rb';

dir_wormdata = '../../wormdata/';
filename_species_conf = '../etc/celegans.yaml';

gff = GFF.new();

filename_gff = dir_wormdata+'WS150/elegansWS150.PCR_product.gff';
filename_output = '../data/celegans/pcr_product_index.WS150';
gff.source_condition = nil;
gff.attribute_condition = nil;

pcr_gff = gff.load_gff( filename_gff );

regex_pcr_name = /PCR_product "([A-Za-z0-9\.\_\:\-\[\]\#]+)"/;

file_output = File.new(filename_output,'w');
$stderr.puts "Write #{filename_output}";
pcr_gff.each { |tmp_gff|
    chromosome = tmp_gff.seqname;

    pcr_match = regex_pcr_name.match(tmp_gff.attribute);
    if( pcr_match != nil )
        file_output.puts "#{pcr_match[1]}\t#{chromosome}\t#{tmp_gff.start}";
    else
        $stderr.puts 'No match : '+tmp_gff.attribute;
    end
}
file_output.close();
