#!/usr/bin/ruby -w

require '../lib/gff.rb';
require '../lib/gmm.rb';

dir_wormdata = '../../wormdata/';

gff = GFF.new();

## For gene
filename_gff = dir_wormdata+'WS150/elegansWS150.CDS.gff';
filename_output = '../data/celegans/gene_index.WS150';
gff.source_condition = nil;
gff.attribute_condition = nil;

genes_gff = gff.load_gff( filename_gff );

regex_transcript_name = /Transcript "([A-Za-z0-9\.]+)"/;
regex_wbgene_id = /Gene "(WBGene[0-9]+)"/;
regex_cds_name = /CDS "([A-Za-z0-9\.]+)"/;
regex_wormpep_id = /WormPep "(WP:CE[0-9]+)"/;

file_output = File.new(filename_output,'w');
$stderr.puts "Write #{filename_output}";
genes_gff.each { |tmp_gff|
    chromosome = tmp_gff.seqname;

    transcript_match = regex_transcript_name.match(tmp_gff.attribute);
    if( transcript_match != nil )
        file_output.puts "#{transcript_match[1]}\t#{chromosome}\t#{tmp_gff.start}";
    end
    
    wbgene_match = regex_wbgene_id.match(tmp_gff.attribute);
    if( wbgene_match != nil )
        file_output.puts "#{wbgene_match[1]}\t#{chromosome}\t#{tmp_gff.start}";
    end
    
    cds_match = regex_cds_name.match(tmp_gff.attribute);
    if( cds_match != nil )
        file_output.puts "#{cds_match[1]}\t#{chromosome}\t#{tmp_gff.start}";
    end

    wormpep_match = regex_wormpep_id.match(tmp_gff.attribute);
    if( wormpep_match != nil )
        file_output.puts "#{wormpep_match[1]}\t#{chromosome}\t#{tmp_gff.start}";
    end
}
