#!/usr/bin/ruby -w

class GFFElement
    attr_accessor :seqname, :source, :feature, :start, :end, :score, :strand, 
        :frame, :attribute;
    
    def initialize(raw_line)
        raw_line.chomp!();
        (@seqname, @source, @feature, @start, @end, @score, @strand, 
            @frame, @attribute) = raw_line.split(/\t/);
    end
end

class GFF
    attr_accessor :source_condition, :attribute_condition;

    def load_gff(filename_gff)
        rv = Array.new();
        file_gff = File.new(filename_gff);
        file_gff.each_line { |line|
            tmp_element = GFFElement.new( line );
            if( @source_condition != nil )
                next if(tmp_element.source !~ /#{@source_condition}/ );
            end

            if(@attribute_condition != nil )
                next if(tmp_element.attribute !~ /#{@attribute_condition}/);
            end

            rv << tmp_element;
        }
        file_gff.close();

        return rv;
    end
end
